// File: /home/sopress/society-v2/wp-content/themes/society/js/_modules.js
var Society = Society || {};
Society.modules= {}
document.addEventListener('DOMContentLoaded', () => {
  for (const module in Society.modules) {
    if ('start' in Society.modules[module]) {
      Society.modules[module].start()
    }
  }
})
window.addEventListener('load', () => {
    for (const module in Society.modules) {
      if ('load' in Society.modules[module]) {
        Society.modules[module].load()
      }
    }
  })
  

// File: /home/sopress/society-v2/wp-content/themes/society/js/includes/api.js

async function api(endpoint, options = {}) {
    options.credentials = 'include';

    const query = options.query || {};

    if (Object.keys(query).length) {
        delete options.query;
        endpoint += '?' + new URLSearchParams(query)
    }

    let root = Society.settings.api;
    if (endpoint.startsWith('/api/')) {
        root = document.location.origin;
    }
    const url = rtrim(root, '/') + '/' + ltrim(endpoint, '/');
    console.log({ url })
    const response = await fetch(url, options);
    if (!response.ok) {
        throw new Error(`HTTP error! Status: ${response.status}`);
    }
    return response.json();
}



// File: /home/sopress/society-v2/wp-content/themes/society/js/includes/string.js
function ltrim(str, chars = "\\s") {
    return str.replace(new RegExp(`^[${chars}]+`), '');
}

function rtrim(str, chars = "\\s") {
    return str.replace(new RegExp(`[${chars}]+$`), '');
}


// File: /home/sopress/society-v2/wp-content/themes/society/js/includes/templates.js
function updateTemplate(templateName, content) {
    const template = document.querySelector(`[data-template="${templateName}"]`);
    if (!template) return;

    template.innerHTML = content;
}



// File: /home/sopress/society-v2/wp-content/themes/society/js/includes/utils.js
function getCanonical() {
    let canonical = document.querySelector('link[rel="canonical"]')?.href;

    if (!canonical) {
        canonical = document.querySelector('meta[property="og:url"]')?.content;
    }

    return canonical || window.location.href.split('#')[0];
}

function getPostId() {
    return document.querySelector('meta[name="post_id"]')?.getAttribute('content') || false
}

/**
 * Charge dynamiquement un fichier JavaScript externe et exécute une fonction une fois le fichier chargé.
 *
 * @param {string} url - L'URL du fichier JavaScript à charger.
 * @param {function} callback - La fonction à exécuter une fois le fichier chargé.
 */
function loadScript(url, callback) {
    const script = document.createElement('script');
    script.src = url;
    script.async = true;
    script.onload = () => callback();
    script.onerror = () => console.error(`Erreur de chargement du script : ${url}`);
    document.head.appendChild(script);
  }
  

// File: /home/sopress/society-v2/wp-content/themes/society/js/modules/pubs.js
Society.modules.Pubs = (() => {
    return {
        load() {

            Sopress.shortcuts.add({
                name: 'Bandeau',
                sequence: ['b'],
                action: () => {
                    App.modules.bandeau.show()
                }
            });

        }
    }
})();

// File: /home/sopress/society-v2/wp-content/themes/society/js/modules/qiota.js
Society.modules.Qiota = (() => {
    const QIOTA_PARTNER_ID = 53;
    // const QIOTA_SCRIPT_SRC = 'https://static.qiota.com/assets/getQiota.js';
    // const QIOTA_TOKEN = '';
    function contentOpened() {
        const urlParams = new URLSearchParams(window.location.search);
        const uid = urlParams.get('uid');
        const hasUid = uid !== null && uid.trim() !== '';
        return hasUid;
    }
    function loadQiota(data) {
        console.log(data.consent ? "Consentement donné, Qiota chargé avec consentement." : "Consentement non donné, Qiota chargé sans consentement.");

        console.log('loadQiota', 'start');
        window.q_token = QIOTA_TOKEN;
        window.q_consent = data.consent || false;
        window.q_logged = false;
        window.q_subscribed = false;

        const qiota = document.createElement('script');
        qiota.src = QIOTA_SCRIPT_SRC + '?consent=' + window.q_consent;
        console.log('qiota.src', qiota.src);
        qiota.id = 'qiota';
        qiota.async = true;
        qiota.onload = () => {
            console.log('loadQiota', 'load');
            console.log('window.q_consent', window.q_consent);

            const pid = getPostId();
            if (pid) {
                window.q_ressource_uri = getCanonical();
                window.q_id_article = pid;
            }
            Society.modules.Session.go();
        };

        (document.head || document.body).appendChild(qiota);
    }


    function checkSirdataConsent(vendorId, callback) {
        __tcfapi('addEventListener', 2, (tcData, success) => {
            if (success && (tcData.eventStatus === 'tcloaded' || tcData.eventStatus === 'useractioncomplete')) {
                const consentOk = tcData.vendor.consents[vendorId] || false;
                callback(consentOk);
            }
        });
    }
    function loadQiotaTest() {
        window.q_type = "keepsession";
        window.q_token = QIOTA_TOKEN;
        window.q_urlcallback = "https://www.societymag.fr/confirmation-achat/";
        window.q_ressource_uri = getCanonical();
        window.q_id_article = getPostId();
        window.q_consent = true;

        const qiota = document.createElement('script');
        qiota.src = QIOTA_SCRIPT_SRC + '?consent=' + window.q_consent;
        qiota.id = 'qiota';
        qiota.async = true;
        qiota.onload = () => {
            console.log('loadQiotaTest', 'load');
            setupQiota(function (response) {
                if (response) {
                    renderQiotaAuth(q_token, q_urlcallback, q_type);
                    return;
                }
            });
        };
        (document.head || document.body).appendChild(qiota);

    }
    function start() {

        window.addEventListener('scroll', () => {

            if (QIOTA_TEST) {
                return loadQiotaTest()
            }
            const qiotaConsent = sessionStorage.getItem('qiota-consent');
            if (qiotaConsent === null) {
                checkSirdataConsent(QIOTA_PARTNER_ID, consent => {
                    loadQiota({ consent });
                    sessionStorage.setItem('qiota-consent', consent)
                });
            } else {
                loadQiota({ consent: qiotaConsent === 'true' });
            }
        }, { once: true });
    }

    return { start, loadQiota };
})();


// File: /home/sopress/society-v2/wp-content/themes/society/js/modules/search.js
Society.modules.Search = (() => {

    function start() {
        const searchInput = document.querySelector('form#recherche input[name="s"]');
        let timeout = null;

        if (!searchInput) return;

        searchInput.addEventListener("input", function () {
            clearTimeout(timeout);

            timeout = setTimeout(() => {
                const query = searchInput.value.trim();

                const searchUrl = `./?s=${encodeURIComponent(query)}`;

                fetch(searchUrl)
                    .then(response => response.text())
                    .then(html => {
                        const parser = new DOMParser();
                        const doc = parser.parseFromString(html, "text/html");

                        // Remplace le body de la page avec le nouveau contenu
                        document.querySelector('#taxonomies').innerHTML = doc.querySelector('#taxonomies').innerHTML;
                        document.querySelector('#resultats').innerHTML = doc.querySelector('#resultats').innerHTML;

                        // Met à jour l'URL sans recharger la page
                        window.history.pushState({}, '', searchUrl);

                        // Réattache les événements après mise à jour du DOM
                        document.dispatchEvent(new Event("DOMContentLoaded"));
                    })
                    .catch(error => console.error("Erreur de chargement de la recherche :", error));
            }, 300); // Déclenche après 300ms d'inactivité
        });

        // Gestion de la navigation avec les boutons "Précédent" et "Suivant"
        window.addEventListener("popstate", function () {
            location.reload(); // Recharge la page lorsqu'on navigue dans l'historique
        });
    }

    return {
        start,
    };

})();


// File: /home/sopress/society-v2/wp-content/themes/society/js/modules/session.js
Society.modules.Session = (() => {
    function isConnected() {
        return document.cookie.split('; ').some(cookie =>
            cookie.startsWith("is_connected")
        )
    }
    function loadPostContent(uid = false) {
        if (window.get_single_content) return;
        window.get_single_content = true;
        if (!document.querySelector('.article .qiota')) return;
        const trace = document.querySelector('input[name="trace"]')?.value;
        if (trace) {
            loadScript('https://cdnjs.cloudflare.com/ajax/libs/pako/2.1.0/pako.min.js', function () {
                setContent(decodeAndDecompress(trace));
            })
        } else {
            api('/api/content/', { query: { id: getPostId(), uid } }).then(data => {
                // console.log('get_single_content', data);
                setContent(data.body)
            })
                .catch(error => {
                    console.error('Erreur lors de la requête:', error);
                });
        }
    }

    function decodeAndDecompress(encoded) {
        const compressed = Uint8Array.from(atob(encoded), c => c.charCodeAt(0));
        const decompressed = window.pako.inflate(compressed);
        return new TextDecoder().decode(decompressed);
    }

    function setContent(body) {

        document.querySelector('.article .content>div').innerHTML = body;
        const el = document.querySelector('.article .content>div');
        const rect = el.getBoundingClientRect();

        if (rect.top < 0) {
            el.scrollIntoView({ behavior: 'smooth' });
        }
        document.dispatchEvent(new Event("DOMContentLoaded"));

        // try {
        //     setTimeout(() => {
        //         Neil.loaders()
        //     }, 500);
        // } catch (e) {
        //     console.log(e);
        // }
    }
    function activatePaywall(callback) {
        if (Society?.article?.gratuit) return;

        document.addEventListener('q_newsletter_subscribed', function (e) {
            loadPostContent();
        });

        document.addEventListener('q_qiotaComplete', function (event) {
            if (!event.q_paywallDisplayed) {
                const urlParams = new URLSearchParams(window.location.search);
                const uid = urlParams.get('uid');
                loadPostContent(uid);
            }
        });

        try {
            setupQiota(function (response) {

                setTimeout(() => {
                    document.querySelectorAll('#q_subscribe a').forEach(link => {
                        const url = getCanonical();
                        const href = '/achat.php?page=' + link.href + '&url=' + encodeURI(url);
                        link.href = href;
                    });
                }, 1000)
                console.log('window.q_logged', window.q_logged)
                console.log('window.q_subscribed', window.q_subscribed)
                console.log('window.q_consent', window.q_consent)

                if (window.q_subscribed) {
                    if (window.scrollY) {
                        loadPostContent();
                    } else {
                        window.addEventListener('scroll', loadPostContent, { once: true });
                    }
                }
                if (!response) {
                    console.log('Qiota error :', response);
                    return;
                }
                console.log('Qiota init :', response);
            });
        } catch (e) {
            console.log('Qiota is not ready');
        }
    }
    function go() {
        if (window.sessionready) return activatePaywall();
        window.sessionready = true;

        try {
            Sopress.shortcuts.add({
                name: 'Content',
                sequence: ['c'],
                action: () => {
                    loadPostContent()
                }
            });
        } catch (e) { console.log(e) }

        console.log('session', 'isConnected ?')

        if (!isConnected()) return activatePaywall();
        console.log('session', 'startLoad')
        startLoad('.ctas', 'right');
        api('/api/partial/', { query: { template: 'login-link', pid: getPostId() } })
            .then(data => {
                updateTemplate('login-link', data.html);
                endLoad('.ctas');

                document.documentElement.dataset.connecte = true;
                document.documentElement.dataset.abonne = data.is_abonne;

                window.q_subscribed = data.is_abonne || data.can_read;
                window.q_logged = true;

                // if (!data.is_abonne) {
                //     // activatePaywall()
                // }
                activatePaywall()

            }).catch(error => console.error(error));

    }
    return {
        isConnected,
        go,
        activatePaywall
    };
})();

// File: /home/sopress/society-v2/wp-content/themes/society/js/modules/site.js
Society.modules.Site = (() => {

    function start() {
        const htmlElement = document.documentElement; // Select the <html> element

        // Remove 'no-js' class (indicating JavaScript is enabled)
        if (htmlElement.classList.contains('no-js')) {
            htmlElement.classList.remove('no-js');
            htmlElement.classList.add('js'); // Optionally add 'js' class
        }

        // Check for SVG support and handle the 'no-svg' class
        const supportsSVG = document.createElementNS && document.createElementNS('http://www.w3.org/2000/svg', 'svg').createSVGRect !== undefined;
        if (supportsSVG) {
            htmlElement.classList.remove('no-svg');
            htmlElement.classList.add('svg'); // Optionally add 'svg' class
        }


    }
    return {
        start,
    };
})();
